/*
	Project Xenoverse
	By Geldon Yetichsky

notes:
	The attack datum tracks damage inflicted throughout the game.
	It's mostly handy just to pass multiple bits of information when attacks are done, such as who attacked, what type of
	damage, and the power of the attack.

*/

var/const/ELECTRICAL_ATTACK_TYPE = "electric"

Attack
	var
		power // How powerful the attack was
		attackType // What type of attack it was.

	var/mob/player/responsibleAtom

	var/mob/actor // Who performed the attack

	// All args are optional, since they can always be assigned after the creation of the Attack datum.
	New(var/newPower,var/newAttackType,var/atom/newResponsibleAtom)
		if (newPower != null)
			if (isnum(newPower))
				power = newPower
			else
				DebugMsg("[type].Attack() created with arg 1 as non-numeric.  Aborting.")
				del src

		if (newAttackType != null)
			attackType = newAttackType
			// Would be easy enough to run a check against all known attack types, but I don't have them settled yet.

		if (newResponsibleAtom != null)
			if (istype(newResponsibleAtom,/atom))
				responsibleAtom = newResponsibleAtom
			else
				DebugMsg("[type].New() created with arg 3 as a non-atom.  Aborting.")
				del src

	/* Returns a generic descriptor of the type of damage taken. */
	proc/GetDamageWord()

		if (attackType != null)
			return(attackType)
		else
			return("generic")

