/*
	Project Xenoverse
	By Geldon Yetichsky

file:
Client.dm

notes:
Handles basic client object definition.
*/

client

		/* Used for shifting about the eye with the cursor.
	var/tmp/eyex
	var/tmp/eyey
	var/tmp/eyez
		*/

		/*
			SOUND_CHANNEL_MIN - SOUND_CHANNEL_MAX are the channels allocated to noises.
		*/
	var/const/SOUND_CHANNEL_MIN = 5
	var/const/SOUND_CHANNEL_MAX = 500

	var/tmp/lastSentSoundChannel

	/* GetAvailableSoundChannel
		There's a limited number of sound channels available.  This cycles through these channels one at a time and
		returns the least recently cycled. */
	proc/GetAvailableSoundChannel()

		if (lastSentSoundChannel == null || lastSentSoundChannel == SOUND_CHANNEL_MAX)
			lastSentSoundChannel = SOUND_CHANNEL_MIN

		spawn()
			lastSentSoundChannel++
		return(lastSentSoundChannel)




	New()
		sleep(10)

		/* Instead of all this, it is advised in the New proc (client) help to do all this on the mob...*/

		if (mob == null)
			spawn()
				while (mob==null) sleep()
				// A good spot to put any mob to client-related initialization things.
				SkinResetAllStatusInfo()
		..() // without this, connection does not occur

	Stat()

		if (mob == null)
			return()

			// I really don't want this to be interrupted by death, apparently, so I'm putting it here.
		SkinUpdateScanner()

		/*
		..()

		if(statpanel("Help"))
			stat("Movement","Use the cursor keys or QWEADZXC to move.  W or Up is always forward, S or Down is always backwards.  A or Left turns left.  D or Right turns right.")
			stat("Set Ability","To make an ability active, left click it on your available abilities list.  You can also right click on an ability on your available abilities list to assign it to a function key.")
			stat("Use Ability","To use your active ability, simply double-click anywhere on the map you can currently see.")
			stat("Queue","All moves are queued to be performed ahead of time.  Watch the map for indicators of currently queued moves.  Center or S cancels current moves.  Backspace removes the last move from your queue.")
		/*
		UpdateActiveAbility()
		UpdateAbilityHotkey()
		UpdateAbilityBank()
		*/

		*/
		// Normally, I do *not* want to be calling these things constantly but rather when an update has happened.

	verb/tabRespawnChanged()
		switch (winget(src,"tabRespawn","current-tab"))
			if ("paneRespawnIntroduction")
				return()
			if ("paneRespawn")
				RepopulateSpawnChamberGrid()
				return()
			if ("paneRespawnEarthInc")
				SkinPurchaseScreenPopulate()
				return()
			else
				var/tabWas = winget(src,"tabRespawn","current-tab")
				DebugMsg("tabRespawnChanged() does not recognize tab [tabWas]")
		return()

	verb/btnAbilityPurchaseButton()

		if (istype(usr,/mob/player))

			if (activeAbility == null || !(istype(activeAbility,/obj/ability)))
				usr.GameOutput("You will need to select (click on) an ability in order to purchase it.")
				return()

				// This would likely involve cheating.
			if (!(usr in respawnArea))
				usr.GameOutput("You need to have dematerialized in order to purchase an ability.")
				return()

			activeAbility.Purchase(usr)

		else

			DebugMsg("btnAbilityPurchaseButton() activated by non-/mob/player")

	/*	Pretty cool code to have if I ever decide to allow the players to get all discombobulated.

	proc/SetupMobView()
		eye = mob
		perspective = MOB_PERSPECTIVE

	proc/SetupEyeView()

		eyex = mob.x
		eyey = mob.y
		eyez = mob.z
		perspective = EYE_PERSPECTIVE

	proc/ShiftClientView(var/xshift, var/yshift)

		if (perspective == MOB_PERSPECTIVE) SetupEyeView()

		eyex = eyex + xshift
		eyey = eyey + yshift

			// First check to make sure we haven't left the bounds of the map.
		if (eyex < 1)
			eyex = 1
		if (eyex > world.maxx)
			eyex = world.maxx
		if (eyey < 1)
			eyey = 1
		if (eyey > world.maxy)
			eyey = world.maxy

			// Second, check to make sure we haven't gone out of acceptable view straying range.
			// Hmm, easier said than done if the mob is moving.

		eye = locate(eyex, eyey, mob.z)

	*/


	verb/say(var/textToSay as text)
		set src = usr
		set name = "Say"
		set desc = "Speak audiably to anyone within close proximity."

		var/const/SAYRANGE = 20

		// Spam checks should be run

		orange(SAYRANGE,mob) << "[mob.name] says, \"[textToSay]\""

		var/tmp/list/mob/thoseInRange = new/list()

		for (var/mob/thisMob in view(SAYRANGE,mob))
			if (thisMob == usr) // The reason I'm doing it this way instead of using oView is so those in same space can hear.
				continue
			thoseInRange.Add(thisMob)

		if (thoseInRange.len == 0)
			src << "You say, \"[textToSay]\" to no apparent listeners."
		else
			src << "You say, \"[textToSay].\""

		del thoseInRange
