/*
	Project Xenoverse
	By Geldon Yetichsky

file:
ClientControls.dm

Notes:
Handles input-related aspects of the client object.
*/

client

	/* These are bound to the QWERASDFZXCV keys, also the keypad equivilents (with -, +, and Enter being the far right keys. */
	var/obj/ability/Ability_Q
	var/obj/ability/Ability_W
	var/obj/ability/Ability_E
	var/obj/ability/Ability_R
	var/obj/ability/Ability_A
	var/obj/ability/Ability_S
	var/obj/ability/Ability_D
	var/obj/ability/Ability_F
	var/obj/ability/Ability_Z
	var/obj/ability/Ability_X
	var/obj/ability/Ability_C
	var/obj/ability/Ability_V

	North()
		ActivateKeypad("W")

	Northeast()
		ActivateKeypad("E")

	East()
		ActivateKeypad("D")

	Southeast()
		ActivateKeypad("C")

	South()
		ActivateKeypad("X")

	Southwest()
		ActivateKeypad("Z")

	West()
		ActivateKeypad("A")

	Northwest()
		ActivateKeypad("Q")

	Center()
		ActivateKeypad("S")

/* The function keys' primary purpose is to activate one of 12 functions tied to the current mode of game functionality.
   What they actually end up doing, then, is queue an appropriate ActionHandler command. */

	verb/btnF1()
		set hidden = 1
		set src = usr

		activeAbility=F1Ability
		UpdateActiveAbility()

	verb/btnF2()
		set hidden = 1
		set src = usr

		activeAbility=F2Ability
		UpdateActiveAbility()

	verb/btnF3()
		set hidden = 1
		set src = usr

		activeAbility=F3Ability
		UpdateActiveAbility()

	verb/btnF4()
		set hidden = 1
		set src = usr

		activeAbility=F4Ability
		UpdateActiveAbility()

	verb/btnF5()
		set hidden = 1
		set src = usr

		activeAbility=F5Ability
		UpdateActiveAbility()

	verb/btnF6()
		set hidden = 1
		set src = usr

		activeAbility=F6Ability
		UpdateActiveAbility()

	verb/btnF7()
		set hidden = 1
		set src = usr

		activeAbility=F7Ability
		UpdateActiveAbility()


	verb/btnF8()
		set hidden = 1
		set src = usr

		activeAbility=F8Ability
		UpdateActiveAbility()


	verb/btnF9()
		set hidden = 1
		set src = usr

		activeAbility=F9Ability
		UpdateActiveAbility()


	verb/btnF10()
		set hidden = 1
		set src = usr

		activeAbility=F10Ability
		UpdateActiveAbility()


	verb/btnF11()
		set hidden = 1
		set src = usr

		activeAbility=F11Ability
		UpdateActiveAbility()


	verb/btnF12()
		set hidden = 1
		set src = usr

		activeAbility=F12Ability
		UpdateActiveAbility()

	verb/backspace()
		set hidden = 1
		set src = usr

		mob.NewInterrupt("RemoveLast")

	/* ActivateKeypad()
		Expected args are Q, W, E, R, A, S, D, F, Z, X, C, or V depending on which of these keys (or their keypad
		equivilents) have been hit.  if Ability_[Key] is not null, executes Activate. */

	proc/ActivateKeypad(var/whichKey)

		if (mob == null) // Premature to do this, then.
			DebugMsg("ActivateKeypad(): Mob was null.")
			return()
		else if (!(mob.IsAlive()))
			return()

		switch (whichKey)
			if ("Q")
				if (Ability_Q != null) Ability_Q.Activate(mob,NORTHWEST)
			if ("W")
				if (Ability_W != null) Ability_W.Activate(mob,NORTH)
			if ("E")
				if (Ability_E != null) Ability_E.Activate(mob,NORTHEAST)
			if ("R")
				if (Ability_R != null) Ability_R.Activate(mob)
			if ("A")
				if (Ability_A != null) Ability_A.Activate(mob,WEST)
			if ("S")
				if (Ability_S != null) Ability_S.Activate(mob)
			if ("D")
				if (Ability_D != null) Ability_D.Activate(mob,EAST)
			if ("F")
				if (Ability_F != null) Ability_F.Activate(mob)
			if ("Z")
				if (Ability_Z != null) Ability_Z.Activate(mob,SOUTHWEST)
			if ("X")
				if (Ability_X != null) Ability_X.Activate(mob,SOUTH)
			if ("C")
				if (Ability_C != null) Ability_C.Activate(mob,SOUTHEAST)
			if ("V")
				if (Ability_V != null) Ability_V.Activate(mob)
			else
				DebugMsg("[type].ActivateKeypad() does not recognize key: [whichKey]")

	/* SetKeypadToMovement()
		Basically fills in the Ability_Q through Ability_V keys to the global abilities for movement. */
	proc/SetKeypadToMovement()
		Ability_Q = GLOBAL_ABILITY_NULL
		Ability_W = GLOBAL_ABILITY_STEP_FORWARD
		Ability_E = GLOBAL_ABILITY_NULL
		Ability_A = GLOBAL_ABILITY_TURN_LEFT
		Ability_S = GLOBAL_ABILITY_CANCEL_ACTIONS
		Ability_D = GLOBAL_ABILITY_TURN_RIGHT
		Ability_F = GLOBAL_ABILITY_NULL
		Ability_Z = GLOBAL_ABILITY_SIDESTEP_LEFT
		Ability_X = GLOBAL_ABILITY_STEP_BACKWARDS
		Ability_C = GLOBAL_ABILITY_SIDESTEP_RIGHT
		Ability_V = GLOBAL_ABILITY_NULL

		SkinPopulateControlBreakdown()

