/*
	The Beautification engine is just a process that continually runs and applies appropriate texturing to the various
	turfs, spacing out the process of texturing in such a way as to not bog down the game.
*/

var/list/BeautificationQueue
var/turf/lastThingBeautified

proc/BeautificationDaemon()

	/* Tests reveal an interesting result
	   10 tic wait with 100 spaces per tic = noticable lag.
	   1 tic wait with 25 spaces per tic = not noticable lag.
	   The game is undoubtedly a bit slower, but so logn as the player doesn't notice, what's it matter?
	   (I'll probably need to tweak things a bit when actual code is running.) */

	var/spacesDone = 0
	var/const/SPACES_PER_TIC = 15

	spawn()
		sleep(10)
		// DebugMsg("Beautification Process Begun.  [BeautificationQueue.len] to go!")

		while(world.IsRunning())

			if (BeautificationQueue.len == 0)
				sleep(10)
				continue

			spacesDone++

			if (spacesDone > SPACES_PER_TIC)
				sleep(1)
				spacesDone = 0

			/* Taking the last member first assures that whenever the players might be is the most likely thing to be affected first. */
			if (lastThingBeautified == BeautificationQueue[BeautificationQueue.len])
				BeautificationQueue.Cut(BeautificationQueue.len-1,BeautificationQueue.len)
				// Works like a charm to do 10x the work.  (Good thing too, considering I've apparently so many redundant turfs beign added.)
				spacesDone = spacesDone - 0.9
				continue

			lastThingBeautified = BeautificationQueue[BeautificationQueue.len]
			lastThingBeautified.Beautify()
			BeautificationQueue.Cut(BeautificationQueue.len-1,BeautificationQueue.len)
