/*
	Project Xenoverse
	By Geldon Yetichsky

file:
ObjEffects.dm

notes:
	These objects are basically used for temporary visual effects.  They have no real gameplay impact beyond that.
*/

obj/effects

	mouse_opacity = 0 // This is how effects are all completely insubstantial
	opacity = 0
	density = 0

	icon = 'imgEffects.dmi'

		// Tried putting a sound effect on the New() here but no dice.  It's because it's not actually being new() initialized.

	wallcrack
		icon_state = "wallcrack"

	wallcrack2
		icon_state = "wallcrack2"

	wallcrack3
		icon_state = "wallcrack3"

	wallcrack4
		icon_state = "wallcrack4"

	wallcrack5
		icon_state = "wallcrack5"

	groundsparks
		luminosity = 1

		New(var/loc,var/direction)
			spawn()
				icon_state = "groundsparks"
				if (direction == null)
					switch (rand (1,8))
						if (1)
							dir = NORTH
						if (2)
							dir = NORTHEAST
						if (3)
							dir = EAST
						if (4)
							dir = SOUTHEAST
						if (5)
							dir = SOUTH
						if (6)
							dir = SOUTHWEST
						if (7)
							dir = WEST
						if (8)
							dir = NORTHWEST
				else
					dir = direction

				Noise(src,'groundsparks.wav')
				sleep(15)
				del src

	crackling
		luminosity = 1

		New(var/loc,var/magnitude)
			if (magnitude == null) magnitude = 1

			spawn()
				icon_state = "crackling"

				sleep(magnitude * 10)
				del src

	wirelessenergy // Gives the players a visual queue that energy has been transferred from the wireless generator here.
		icon = 'imgProjectiles.dmi'
		icon_state = "weakbolt"


	light // Very generic, simply has a light shining here.  Does not handle automatic deletion of said light.

		New(var/location,var/lum)

			if (lum != null)
				luminosity = lum
			else
				luminosity = 2

			// DebugMsg("lum = [lum] but luminosity = [luminosity]")

			// luminosity = 5

			// icon_state = "lightsource"
			/* I can't do this dynamically - way too bloaty.
			   However, if I globally initialize these icons at worldup that should be fine.
			var/icon/myIcon = icon(icon)
			myIcon.Scale(16*luminosity,16*luminosity)
			icon = myIcon
			*/


			..()


		proc/Kill()
			spawn()
				sleep(10) // Why put a sleep in here?  Because I want light to linger for a bit due to latency.
				luminosity = 0
				del src

	// railslice is basically just a split particle effect.  Because it needs to stay behind, it's necessary to make its own item.
	railslice

		New(var/location,var/dir)

			dir = dir

			flick ("railslice",src)

			spawn()
				sleep(10)
				del src

obj/effects/entrancedoor

	icon = 'PlanetTurfs.dmi'

	layer = 5

	New(var/location)
		flick ("entrancedoors",src)

