/*
	Project Xenoverse
	By Geldon Yetichsky

file:
TurfPersonal.dm

notes:
	Personal maps are intended to be navigated by player characters.  Their turfs are sorted into being either floors or walls.
	Floors are essentially the ground and generally do not offer obstruction when passed.
	Walls are essentialls walls and usually offer obstruction to passage and sometimes obstruction to sight.

	Personal turfs are completely destructable, although ones that are part of active facilities will likely be rebuilt when
	damaged.

	The new character ship is primarily protected by not allowing anyone armed with anything that can destroy it from entering.
*/

turf/floor

	icon = 'TurfsFloor.dmi'

	density = 0
	opacity = 0

	New()

		// DrawFloorToWallOverlays() // Relocated to beautify. (which doesn't seem to work)
		..()

	soil
		name = "Bare soil floor"
		desc = "This floor is made up of small pebbles of low-density rock."
		icon_state = "soil"

	plexweave
		name = "Plexweave floor"
		desc = "This floor is made of plexweave, a transparent but comparatively frail synthetic solid material."
		icon_state = "plexweave"

	alchelite
		name = "Alchelite floor"
		desc = "This floor is made of alchelite, a reflective and moderately solid synthetic material."
		icon_state = "alchelite"

	subneutronium
		name = "Subneutronium floor"
		desc = "This floor is made of subneutronium, an incredibly dense solid synthetic material."
		icon_state = "subneutronium"

	transmatrix
		name = "Transmatrix floor"
		desc = "This floor is made of transmatrix, not strictly a material but rather an unbreakable multidimensional anomaly."
		icon_state = "transmatrix"

