/*
	These are the obj/ability related to movement.

	I anticipate having these ones:

	* A main overall "movement" ability that simply queues the action to attempt to move to a space.
	* The individual fine movement abilities.

	Technically, there shoudn't be any special mob movement stuff in here because obj/ability are only visible to players.

	*/

/* stepforward, stepbackward, stepright, stepleft, turnright, and turnleft are all global actions should should not be modified. */

obj/ability/stepforward
	name = "Step forward"
	desc = "Step in the direction you are facing."
	icon_state = "step_forward"

	actionTypeToQueue = /Action/Movement/StepForward

	// This prevents it from being a selectable ability.  Appropriate to keyboard type.
	Click()
		return()

obj/ability/stepbackward
	name = "Step backward"
	desc = "Step opposite of the direction you are facing."
	icon_state = "step_backward"

	actionTypeToQueue = /Action/Movement/StepBackward

	// This prevents it from being a selectable ability.  Appropriate to keyboard type.
	Click()
		return()

obj/ability/turnright
	name = "Turn right"
	desc = "Stand in place and turn to the right (clockwise)."
	icon_state = "turn_right"

	actionTypeToQueue = /Action/Movement/TurnRight

	// This prevents it from being a selectable ability.  Appropriate to keyboard type.
	Click()
		return()

obj/ability/turnleft
	name = "Turn left"
	desc = "Stand in place and turn to the left (counterclockwise)."
	icon_state = "turn_left"

	actionTypeToQueue = /Action/Movement/TurnLeft

	// This prevents it from being a selectable ability.  Appropriate to keyboard type.
	Click()
		return()

obj/ability/stepright
	name = "Step right"
	desc = "Sidestep to the right."
	icon_state = "step_right"

	actionTypeToQueue = /Action/Movement/StepRight

	// This prevents it from being a selectable ability.  Appropriate to keyboard type.
	Click()
		return()

obj/ability/stepleft
	name = "Step left"
	desc = "Sidestep to the left."
	icon_state = "step_left"

	actionTypeToQueue = /Action/Movement/StepLeft

	// This prevents it from being a selectable ability.  Appropriate to keyboard type.
	Click()
		return()

