

/* Energy cannons are basically the devices used to sent bolts of energy away from the energy resources in the game.
    Ideally, these projectiles pass over/through alchelite surfaces and are absorbed by devices which can use that energy...
    but, if you're feeling wasteful, you can also use them as a weapon which causes electrical damage to things which are
    already at their maximum energy. */

obj/device/energycannon

	var/const/SUPPLIED_POWER_REPLENISHED_PER_TURN = 5
	var/const/ENERGY_CANNON_LEVEL_1 = 25
	var/const/ENERGY_CANNON_LEVEL_2 = 50
	var/const/ENERGY_CANNON_LEVEL_3 = 75
	var/const/ENERGY_CANNON_LEVEL_4 = 90 // Blinking "warning, I'm about to shoot!"
	var/const/ENERGY_TO_FIRE = 100 // The cannon builds up this much before firing
	var/const/PROJECTILE_POWER_WHEN_FIRED = 100 // They could differ, if I wanted.
	var/const/MAXIMUM_ENERGY_CANNON_ENERGY = 150

	name = "Energy cannon"
	desc = "Energy cannons build up and fire balls of concentrated electricity."

	icon_state = "energycannon"
	density = 1

	New(var/location, var/initialEnergy)

		if (initialEnergy != null) energy = initialEnergy

		maxEnergy = MAXIMUM_ENERGY_CANNON_ENERGY

		..(location, initialEnergy)

	Heartbeat()

		if (IsActivated())

			if (GetEnergy() > ENERGY_TO_FIRE)
				flick("energycannonfire",src)
				new/obj/projectile/energy(loc,get_step(loc,dir),PROJECTILE_POWER_WHEN_FIRED)
				AdjustEnergy(-ENERGY_TO_FIRE)

		..()

	UpdateAppearance()

		switch (GetEnergy())
			if (1 to ENERGY_CANNON_LEVEL_1)
				icon_state = "energycannon"
				luminosity = 1

			if (ENERGY_CANNON_LEVEL_1 to ENERGY_CANNON_LEVEL_2)
				icon_state = "energycannonlvl1"
				luminosity = 1

			if (ENERGY_CANNON_LEVEL_2 to ENERGY_CANNON_LEVEL_3)
				icon_state = "energycannonlvl2"
				luminosity = 1

			if (ENERGY_CANNON_LEVEL_3 to ENERGY_CANNON_LEVEL_4)
				icon_state = "energycannonlvl3"
				luminosity = 2

			if (ENERGY_CANNON_LEVEL_4 to MAXIMUM_ENERGY_CANNON_ENERGY)
				icon_state = "energycannonlvl4"
				luminosity = 1

			else
				icon_state = "energycannon"
				luminosity = 0
