var/const/WIRELESS_TRANSMITTER_ENERGY_RESUPPLIED_PER_TURN_PER_UNIT = 5

obj/device/wirelesstransmitter

	icon = 'imgDevices.dmi' // In time, I think I should probably make one img for each type of device...

	/*
	   Wireless transmitters are basically futuristic energy distribution methods that allow for cordless energy
	   distribution.  Just about all devices have the ability to receive wireless energy, and the transmitter is
	   able to intelligently determine which devices should get energy.
	*/

	var/turnsToWaitToCheckAgain

	name = "Wireless Energy Transmitter"
	desc = "Wireless transmitters send energy to all nearby devices."
	icon_state = "wirelesscoiloffline"

	density = 1

	New(var/location,var/initialEnergy)

		..(location, initialEnergy)

	/* The Heartbeat process of the wireless transmitter (aside from maintaining its power) checks all devices
	   within range periodically (ever TIME_IN_MS_BETWEEN_CHECKING_FOR_NEW_DEVICES_TO_POWER ms) and adds them to
	   its thingsBeingSuppliedWithPower list.  By simply being on that list, these devices IsBeingSupplied() checks
	   should succeed. */

	Heartbeat()

		if (IsActivated())

			var/list/obj/device/devicesToPower = new/list()

			for (var/obj/device/thisDevice in range(src,WIRELESS_ENERGY_TRANSMITTER_MAX_RANGE))

				if (thisDevice.type == /obj/device/wirelesstransmitter)
					continue
				if (thisDevice.type == /obj/device/energyfont)
					continue

				devicesToPower.Add(thisDevice)

			while (devicesToPower.len > 0 && GetEnergy() > WIRELESS_TRANSMITTER_ENERGY_RESUPPLIED_PER_TURN_PER_UNIT)

				var/obj/device/randomlyPickedDevice = pick(devicesToPower)
				devicesToPower.Remove(randomlyPickedDevice)

				if (GetEnergy() < WIRELESS_TRANSMITTER_ENERGY_RESUPPLIED_PER_TURN_PER_UNIT)
					break

				randomlyPickedDevice.Jolt(WIRELESS_TRANSMITTER_ENERGY_RESUPPLIED_PER_TURN_PER_UNIT)
				AdjustEnergy(-WIRELESS_TRANSMITTER_ENERGY_RESUPPLIED_PER_TURN_PER_UNIT)
		..()

	UpdateAppearance()
		if (icon_state == "wirelesscoilonline")
			if (!IsActivated())
				icon_state = "wirelesscoiloffline"
				luminosity = 0
			else if (IsActivated())
				icon_state = "wirelesscoilonline"
				luminosity = 1


