	/*
		Energy fonts basically provide unlimited power to whatever device is placed in the same space.

		They provide a slow trickle of energy by first fulling themselves to their maxEnergy and then
		transferring that amount of energy into whatever is on the same space.

		It's necessary for them to have a Heartbeat, after all, because it's entirely possible some renegade will come
		and try to suck the power out of them.   Then what?
	*/

var/const/ENERGY_FONT_POWER_GENERATED_PER_TURN = 100

obj/device/energyfont

	name = "Power source"
	desc = "There is a steady power source being radiated from this location that will assure whatever device is placed there will be continually supplied with power."
	icon_state = "energyfont"

	density = 0
	luminosity = 2
	layer = 2.5 // Is 2.5 working?

	New(var/location, var/initialEnergy)
		maxEnergy = 500
		energy = GetMaxEnergy()

		..(location,initialEnergy)

		// Energy font's heartbeat is activated by SparkOfLifeGo.
	Heartbeat()


		for (var/obj/device/thisDevice in src.loc)
			if (thisDevice == src)
				continue
			// var/maxiumAmountToCharge = thisDevice.GetMaxEnergy() - thisDevice.GetEnergy()
			// thisDevice.Jolt(min(ENERGY_FONT_POWER_GENERATED_PER_TURN,maxiumAmountToCharge))
			// DebugMsg("[type].Heartbeat() Energy Font running, adjusted [thisDevice]")
			thisDevice.Jolt(ENERGY_FONT_POWER_GENERATED_PER_TURN)
			break // Only one device at a time... granted, only one device should exist in your turf.

			// In case some greedy renegade is siphoning it
		if (GetEnergy() < GetMaxEnergy())
			AdjustEnergy(ENERGY_FONT_POWER_GENERATED_PER_TURN)

		..()

		// ..() // energyFonts do not fall to teh standard heartbeat procedure
